//TODO: 工具函数移到单独文件
window.__mei_wei__ = window.__mei_wei__ || {};
window.__mei_wei__.util = window.__mei_wei__.util || {};

/**
 * @brief base64方法集合
 * @description 对字符串进行base64 encode&decode处理
 */
window.__mei_wei__.util["Base64"] = {
    // private property
    _keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

    // public method for encoding
    encode : function (input) {
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;

        input = this._utf8_encode(input);

        while (i < input.length) {

            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);

            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;

            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }

            output = output +
            this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
            this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);

        }

        return output;
    },

    // public method for decoding
    decode : function (input) {
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;

        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

        while (i < input.length) {

            enc1 = this._keyStr.indexOf(input.charAt(i++));
            enc2 = this._keyStr.indexOf(input.charAt(i++));
            enc3 = this._keyStr.indexOf(input.charAt(i++));
            enc4 = this._keyStr.indexOf(input.charAt(i++));

            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;

            output = output + String.fromCharCode(chr1);

            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }

        }

        output = this._utf8_decode(output);

        return output;

    },

    // private method for UTF-8 encoding
    _utf8_encode : function (string) {
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";

        for (var n = 0; n < string.length; n++) {

            var c = string.charCodeAt(n);

            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }

        }

        return utftext;
    },

    // private method for UTF-8 decoding
    _utf8_decode : function (utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;

        while ( i < utftext.length ) {

            c = utftext.charCodeAt(i);

            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            }
            else if((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i+1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            }
            else {
                c2 = utftext.charCodeAt(i+1);
                c3 = utftext.charCodeAt(i+2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }

        }

        return string;
    }
}

/**
 * @brief 获取guid
 * 
 */
window.__mei_wei__.util["GetGuid"] = function() {
  function s4() {
    return Math.floor((1 + Math.random()) * 0x10000)
      .toString(16)
      .substring(1);
  }
  return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
    s4() + '-' + s4() + s4() + s4();
}

/**
 * @brief 事件分发机制
 * 
 */
window.__mei_wei__.util["EventEmitter"] = function () {
    this.topics = {};
    this.uuid = 0;
    this.listen = function (topic, callback) {
        if (typeof topic !== "string" || typeof callback !== "function")
            return this;
        if (!this.topics[topic]) {
            this.topics[topic] = [];
        }
        callback.uuid = this.uuid++;
        this.topics[topic].push(callback);
        return this;
    };
    this.trigger = function (src, topic, data) {
        if (!this.topics[topic] || this.topics[topic].length === 0)
            return this;
        var callbacks = this.topics[topic],
        i = 0,
        length = callbacks.length;
        for (; i < length; i++) {
        console.log("callbacks["+ i + "]:" + callbacks[i]);
            try{
                callbacks[i].call(src, data);
            }catch(e){
              console.log("Error nativeCallback exception:" + e);
            }
        }
        return this;
    };
    this.remove = function (topic, callback) {
        if (!this.topics[topic] || this.topics[topic].length === 0)
            return this;
        var callbacks = this.topics[topic],
        i = 0,
        length = callbacks.length;
        for (; i < length; i++) {
            if (callback.uuid === callbacks[i].uuid) {
                callbacks.splice(i, 1);
                break;
            }
        }
        return this;
    };
}

/**
 * @brief 平台信息
 * 
 */
window.__mei_wei__.util["Platform"] = {
	weixin:  /micromessenger/i.test(navigator.userAgent),
	iphone: /iPhone/i.test(navigator.userAgent),
	ipad: /iPad/i.test(navigator.userAgent),
	ios: /iPhone/i.test(navigator.userAgent) || /iPad/i.test(navigator.userAgent),
	android: /Android/i.test(navigator.userAgent)

	//TODO: 定义美味app特有ua，便于区分是不是在自己的app中
}

/**
* @class MWJSBridge
* @description 内部使用的工具类
* @brief 内部使用工具类
* @private
*/ 
var MWJSBridge = {
	/**
	 * @brief 判断Hybrid API是否可以调用，native在webviewFinishLoad的时候赋值
	 */
	_ready: false,

    _emitter: new window.__mei_wei__.util.EventEmitter(), 

    //callNative的所有回调函数
    __callbackFunctionList: {},

   /**
     * @brief 内部URL跳转, 内部使用
     * @description 内部隐藏iframe，做URL跳转
     * @method _loadIframeForIOS
     * @param {String} url 需要跳转的链接
     */
    _loadIframeForIOS:function(url) {
        if (url.length == 0) {
            return;
        }

        var iframe = document.createElement("iframe");
        var cont = document.body || document.documentElement;

        iframe.style.display = "none";
        iframe.setAttribute('src', url);
        cont.appendChild(iframe);

        setTimeout(function(){
            iframe.parentNode.removeChild(iframe);
            iframe = null;
        }, 200);
    },

   /**
     * @brief 内部组装URL参数, 内部使用
     * @description  内部使用，组装URL参数
     * @return 返回序列化之后的字符串
     * @method makeParamString
     * @param {String} plugin app响应的plugin的名字
     * @param {String} method 该plugin响应的函数
     * @param {JSON} apiParams 扩展参数，json对象
     * @param {Function} callback 业务处理完成之后，callback的函数
     */
    _makeParamString:function(plugin, method, apiParams, callback) {
		var params = {};
        if(window.__mei_wei__.util.Platform.android) {
            params.apiParams = JSON.stringify(apiParams);
        } else {
            params.apiParams = apiParams;
        }
       	
       	params.plugin = plugin;
       	params.method = method;

        if (callback != null) {
            params.cbId = window.__mei_wei__.util.GetGuid();
        	MWJSBridge.__callbackFunctionList[params.cbId] = callback;
        }

        return JSON.stringify(params);
    },

     /**
     * @brief 内部js调用native唯一入口
     * @description  内部使用，调用native API
     * @param {String} plugin 需要处理业务逻辑的模块名，对应native的plugin
     * @param {String} method 需要处理业务逻辑的函数名，对应native的MethodName
     * @param {JSON} apiParams 传递给函数的业务参数
     * @param {Function} callback native处理完成回调此方法，最终传给native的是此函数的guid
     * @method jsCallNative
     * @return false, 表示Hybrid API还不能执行,否则表示正常执行
     */
    jsCallNative:function(plugin, method, apiParams, callback) {
    	if (!MWJSBridge._ready) {
    		return false;
    	}

        var paramString = MWJSBridge._makeParamString(plugin, method, apiParams, callback)
        if (window.__mei_wei__.util.Platform.ios) {
        	//TODO: 定义url
        	var iosJumpURL =  "meiweiHybrid://h5/plugin?param= " + window.__mei_wei__.util.Base64.encode(paramString);
            MWJSBridge._loadIframeForIOS(iosJumpURL); 
        }
        else if (window.__mei_wei__.util.Platform.android) {
            nativeModule = window["__" + plugin + "_android"];//TODO: module命名
            if (nativeModule) {
                nativeModule.call(plugin, paramString);
            }
        }

        return true;
   	},

	/**
	 * @brief H5主动监听Native发送的消息，例如页面显示，前后台切换，网络变更等
	 * @description H5主动监听Native发送的消息，例如页面显示，前后台切换，网络变更等
	 * @param {String} emitMessageName native主动发送消息的名字
	 * @param {Function} callback H5处理该消息的函数
	 * @method addListenerForNativeEmitMessage
	 */
    addListenerForNativeEmitMessage:function(emitMessageName, callback) {
        if (emitMessageName && callback) {
            MWJSBridge._emitter.listen(emitMessageName, callback);
        }
    },

    /**
     * @brief H5移除对native的监听
     */
    removeListenerForNativeEmitMessage: function(emitMessageName, callback) {
        if (emitMessageName && callback) {
            MWJSBridge._emitter.remove(emitMessageName, callback);
        }
    },

	/**
	 * @brief Native调用JS唯一入口
	 * @description  Native内部使用，Native调用JS唯一入口
	 * @param JSON转换成字符串再base64 Encode
	 *		1. native 主动发出的消息
	 *			a. @emitMessageName 	消息名称
	 *			b. @data				数据
	 *		2. native回调js
	 *			a. @cbId				js调用native时传入的回调函数guid
	 *			b. @data				数据
	 */
   	nativeCallback: function(param) {
		if (!param) {
			return false;
		}
		try {
			var jsonObj = JSON.parse(window.__mei_wei__.util.Base64.decode(param));
			if (jsonObj.emitMessageName) { //native 主动发出的消息
                MWJSBridge._emitter.trigger(null, jsonObj.emitMessageName, jsonObj);
			} else { //callback处理完，发送的消息
				var callbackFunc = MWJSBridge.__callbackFunctionList[jsonObj.cbId];
		   		if (callbackFunc) {
		   			var ret = callbackFunc(jsonObj);
		   			delete  MWJSBridge.__callbackFunctionList[jsonObj.cbId];
		   			return ret;
		   		} else {
		   			return false;
		   		}
			}
		} catch(e) {
			console.log("Error nativeCallback exception:" + e);
			return false;
		}
		return true;
   	}

};


var __bridgeReadyCallback = function() {
	MWJSBridge._ready = true;

	MWJSBridge.removeListenerForNativeEmitMessage('bridge_ready', __bridgeReadyCallback);
}

//监听bridge ready事件
//TODO: 定义事件名称
MWJSBridge.addListenerForNativeEmitMessage('bridge_ready', __bridgeReadyCallback)


