(function() {
    var userAgent = navigator.userAgent;
    var Util = {
        Base64: {
            // private property
            _keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

            // public method for encoding
            encode : function (input) {
                var output = "";
                var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
                var i = 0;

                input = this._utf8_encode(input);

                while (i < input.length) {

                    chr1 = input.charCodeAt(i++);
                    chr2 = input.charCodeAt(i++);
                    chr3 = input.charCodeAt(i++);

                    enc1 = chr1 >> 2;
                    enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
                    enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
                    enc4 = chr3 & 63;

                    if (isNaN(chr2)) {
                        enc3 = enc4 = 64;
                    } else if (isNaN(chr3)) {
                        enc4 = 64;
                    }

                    output = output +
                    this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
                    this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);

                }

                return output;
            },

            // public method for decoding
            decode : function (input) {
                var output = "";
                var chr1, chr2, chr3;
                var enc1, enc2, enc3, enc4;
                var i = 0;

                input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

                while (i < input.length) {

                    enc1 = this._keyStr.indexOf(input.charAt(i++));
                    enc2 = this._keyStr.indexOf(input.charAt(i++));
                    enc3 = this._keyStr.indexOf(input.charAt(i++));
                    enc4 = this._keyStr.indexOf(input.charAt(i++));

                    chr1 = (enc1 << 2) | (enc2 >> 4);
                    chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
                    chr3 = ((enc3 & 3) << 6) | enc4;

                    output = output + String.fromCharCode(chr1);

                    if (enc3 != 64) {
                        output = output + String.fromCharCode(chr2);
                    }
                    if (enc4 != 64) {
                        output = output + String.fromCharCode(chr3);
                    }

                }

                output = this._utf8_decode(output);

                return output;

            },

            // private method for UTF-8 encoding
            _utf8_encode : function (string) {
                string = string.replace(/\r\n/g,"\n");
                var utftext = "";

                for (var n = 0; n < string.length; n++) {

                    var c = string.charCodeAt(n);

                    if (c < 128) {
                        utftext += String.fromCharCode(c);
                    }
                    else if((c > 127) && (c < 2048)) {
                        utftext += String.fromCharCode((c >> 6) | 192);
                        utftext += String.fromCharCode((c & 63) | 128);
                    }
                    else {
                        utftext += String.fromCharCode((c >> 12) | 224);
                        utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                        utftext += String.fromCharCode((c & 63) | 128);
                    }

                }

                return utftext;
            },

            // private method for UTF-8 decoding
            _utf8_decode : function (utftext) {
                var string = "";
                var i = 0;
                var c = 0,
                    c1 = 0,
                    c2 = 0,
                    c3 = 0;

                while ( i < utftext.length ) {

                    c = utftext.charCodeAt(i);

                    if (c < 128) {
                        string += String.fromCharCode(c);
                        i++;
                    }
                    else if((c > 191) && (c < 224)) {
                        c2 = utftext.charCodeAt(i+1);
                        string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                        i += 2;
                    }
                    else {
                        c2 = utftext.charCodeAt(i+1);
                        c3 = utftext.charCodeAt(i+2);
                        string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                        i += 3;
                    }

                }

                return string;
            }
        },
        getGuid: function() {
            function s4() {
                return Math.floor((1 + Math.random()) * 0x10000)
                  .toString(16)
                  .substring(1);
            }
            return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
            s4() + '-' + s4() + s4() + s4();
        },
        EventEmitter: function () {
            this.topics = {};
            this.uuid = 0;
            this.listen = function (topic, callback) {
                if (typeof topic !== "string" || typeof callback !== "function")
                    return this;
                if (!this.topics[topic]) {
                    this.topics[topic] = {};
                }
                var _guid = Util.getGuid();
                callback.guid = _guid;
                this.topics[topic][_guid] = callback;
                return this;
            };
            this.trigger = function (src, topic, data) {
                if (!this.topics[topic] || this.topics[topic].length === 0)
                    return this;
                var callbacks = this.topics[topic];
                for(var o in callbacks) {
                    if(callbacks.hasOwnProperty(o)) {
                        callbacks[o].call(src, data);
                    }
                }
                return this;
            };
            this.remove = function (topic, callback) {
                if (!this.topics[topic] || this.topics[topic].length === 0)
                    return this;
                var callbacks = this.topics[topic];
                delete callbacks[callback.guid];
                return this;
            };

            this.removeAll = function(topic) {
                this.topics[topic] = {};
                return this;
            }
        },
        Platform: {
            weixin:  /micromessenger/i.test(userAgent),
            iphone: /iPhone/i.test(userAgent),
            ipad: /iPad/i.test(userAgent),
            android: /Android/i.test(userAgent),
            ios: /iPhone/i.test(userAgent) || /iPad/i.test(userAgent)
        }
    }


    //兼容老营销页webview
    //登陆回调
    var CJLogined = function(sessionid) {
        for(var i = 0; i < oldBridge._callbacks.JCLogin.length; i++) {
            oldBridge._callbacks.JCLogin[i]({
                errorCode: 0,
                data: {
                    token: sessionid
                }
            });
        }

        oldBridge._callbacks.JCLogin = [];
    }

    var oldBridge = {
        _callbacks: {
            JCLogin: []
        },

        jsCallNative: function(plugin, method, param, callback) {
            //登陆
            if(plugin == "authorization" && method == "call_native_login") {
                oldBridge.JCLogin(callback);
                return;
            }

            //页面跳转
            if(plugin == "util" && method == "open_url") {
                var idReg = /id=([^#&]*)/
                //商户详情
                if(param.url.indexOf("shopDetail") === 0) {
                    var match = param.url.match(idReg);
                    if(match && typeof JCShopDetail == 'function') {
                        JCShopDetail(match[1]);
                    }
                } else if(param.url.indexOf("vaildOrders") === 0) {
                    //可用号单列表
                    if(typeof JCVaildOrders == 'function') {
                        JCVaildOrders();
                    }
                } else if(param.url.indexOf("queueOrderDetail") === 0) {
                    // 跳转到排队号单详情
                    var match = param.url.match(idReg);
                    if(match && typeof JCOrderDetail == 'function') {
                        JCOrderDetail(1, match[1])
                    }
                } else if(param.url.indexOf("menuOrderDetail") === 0) {
                    // 跳转到预点菜单号单详情
                    var match = param.url.match(idReg);
                    if(match && typeof JCOrderDetail == 'function') {
                        JCOrderDetail(2, match[1])
                    }
                } else if(param.url.indexOf("bookOrderDetail") === 0) {
                    // 跳转到预订单号单详情
                    var match = param.url.match(idReg);
                    if(match && typeof JCOrderDetail == 'function') {
                        JCOrderDetail(3, match[1])
                    }
                } else if(param.url.indexOf("dealOrderDetail") === 0) {
                    // 跳转到美味买单号单详情
                    var match = param.url.match(idReg);
                    if(match && typeof JCOrderDetail == 'function') {
                        JCOrderDetail(4, match[1])
                    }
                } else if(param.url.indexOf("couponByShops") === 0) {
                    //
                    var match = param.url.match(idReg);
                    if(match && typeof JCCouponByShops == 'function') {
                        JCCouponByShops(match[1])
                    }
                }
                return;
            }
        },

        //调登陆
        JCLogin: function(callback) {
            oldBridge._callbacks.JCLogin.push(callback);

            window.CJLogined = window.CJLogined || CJLogined;
            
            if(typeof JCLogin == 'function' || typeof(window.android.JCLogin) == 'function') {
                window.android.JCLogin() || JCLogin();
            }
        }
    }

    /**
    * @class MWJSBridge
    * @description 内部使用的工具类
    * @brief 内部使用工具类
    * @private
    */ 
    var MWJSBridge = {
        /**
         * @brief 判断Hybrid API是否可以调用，native在webviewFinishLoad的时候赋值
         */
        _ready: false,

        _emitter: new Util.EventEmitter(), 

        //callNative的所有回调函数
        __callbackFunctionList: {},

       /**
         * @brief 内部组装URL参数, 内部使用
         * @description  内部使用，组装URL参数
         * @return 返回序列化之后的字符串
         * @method makeParamString
         * @param {String} plugin app响应的plugin的名字
         * @param {String} method 该plugin响应的函数
         * @param {JSON} apiParams 扩展参数，json对象
         * @param {Function} callback 业务处理完成之后，callback的函数
         */
        _makeParamString:function(plugin, method, apiParams, callback, permanent) {
            var params = {};
            if(Util.Platform.android) {
                params.apiParams = JSON.stringify(apiParams);
            } else {
                params.apiParams = apiParams;
            }
            
            params.plugin = plugin;
            params.method = method;

            if (callback != null) {
                params.cbId = Util.getGuid();
                callback.permanent = permanent;
                MWJSBridge.__callbackFunctionList[params.cbId] = callback;
            }

            return JSON.stringify(params);
        },

        _openUrl: function(apiParams) {
            var _params = [];
            _params.push("protocol=" + (apiParams.protocol || "web"));
            _params.push("url=" + Util.Base64.encode(apiParams.url));
            _params.push("target=" + (apiParams.target || "new"));
            _params.push("showloading=" + (apiParams.showloading || 0));

            window.location.href = "meiwei://wireless?" + _params.join("&");
        },

         /**
         * @brief 内部js调用native唯一入口
         * @description  内部使用，调用native API
         * @param {String} plugin 需要处理业务逻辑的模块名，对应native的plugin
         * @param {String} method 需要处理业务逻辑的函数名，对应native的MethodName
         * @param {JSON} apiParams 传递给函数的业务参数
         * @param {Function} callback native处理完成回调此方法，最终传给native的是此函数的guid
         * @method jsCallNative
         * @return false, 表示Hybrid API还不能执行,否则表示正常执行
         */
        jsCallNative:function(plugin, method, apiParams, callback, permanent) {

            if (!MWJSBridge._ready) {
                oldBridge.jsCallNative(plugin, method, apiParams, callback);
                return false;
            }

            //打开页面通过url与native交互
            if(plugin === 'util' && method === 'open_url') {
                MWJSBridge._openUrl(apiParams);
                return;
            }

            var paramString = MWJSBridge._makeParamString(plugin, method, apiParams, callback, permanent);
            if (Util.Platform.ios) {
                window.webkit.messageHandlers[plugin].postMessage(paramString);
            }
            else if (Util.Platform.android) {
                if (window["__" + plugin + "_android"]) {
                    window["__" + plugin + "_android"].call(plugin, paramString);
                }
            }

            return true;
        },

        /**
         * @brief H5主动监听Native发送的消息，例如页面显示，前后台切换，网络变更等
         * @description H5主动监听Native发送的消息，例如页面显示，前后台切换，网络变更等
         * @param {String} emitMessageName native主动发送消息的名字
         * @param {Function} callback H5处理该消息的函数
         * @method addListenerForNativeEmitMessage
         */
        addListenerForNativeEmitMessage:function(emitMessageName, callback) {
            if (emitMessageName && callback) {
                MWJSBridge._emitter.listen(emitMessageName, callback);
            }
        },

        /**
         * @brief H5移除对native的监听
         */
        removeListenerForNativeEmitMessage: function(emitMessageName, callback) {
            if (emitMessageName && callback) {
                MWJSBridge._emitter.remove(emitMessageName, callback);
            }
        },

        /**
         * @brief Native调用JS唯一入口
         * @description  Native内部使用，Native调用JS唯一入口
         * @param JSON转换成字符串再base64 Encode
         *      1. native 主动发出的消息
         *          a. @emitMessageName     消息名称
         *          b. @data                数据
         *      2. native回调js
         *          a. @cbId                js调用native时传入的回调函数guid
         *          b. @data                数据
         */
        nativeCallback: function(param) {
            if (!param) {
                return false;
            }
            try {
                var jsonObj = JSON.parse(Util.Base64.decode(param));
                if (jsonObj.emitMessageName) { //native 主动发出的消息
                    MWJSBridge._emitter.trigger(null, jsonObj.emitMessageName, jsonObj);
                } else { //callback处理完，发送的消息
                    var callbackFunc = MWJSBridge.__callbackFunctionList[jsonObj.cbId];
                    if (MWJSBridge.__callbackFunctionList[jsonObj.cbId]) {
                        var ret = MWJSBridge.__callbackFunctionList[jsonObj.cbId](jsonObj);
                        if(!MWJSBridge.__callbackFunctionList[jsonObj.cbId].permanent) {
                            delete  MWJSBridge.__callbackFunctionList[jsonObj.cbId];  
                        }
                        return ret; 
                    } else {
                        console.log("Error nativeCallback:" + JSON.stringify(param));
                        return false;
                    }
                }
            } catch(e) {
                console.log("Error nativeCallback exception:" + e);
                return false;
            }
            return true;
        }

    };

    var __bridgeReadyCallback = function() {
        MWJSBridge._ready = true;
        MWJSBridge.removeListenerForNativeEmitMessage('bridge_ready', __bridgeReadyCallback);
    }

    //监听bridge ready事件
    MWJSBridge.addListenerForNativeEmitMessage('bridge_ready', __bridgeReadyCallback);

    if(typeof window != 'undefined') {
        window.MWJSBridge = MWJSBridge;
    }

    if(typeof module != "undefined" && module.exports) {
        module.exports = MWJSBridge;
    }
})();